"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path = require("path");
var JSRuleFinder_1 = require("./shared/JSRuleFinder");
var ReactPlugin = (function () {
    function ReactPlugin() {
    }
    ReactPlugin.prototype.configure = function (builder, spin) {
        var stack = builder.stack;
        if (stack.hasAll(['react', 'webpack'])) {
            var jsRuleFinder_1 = new JSRuleFinder_1.default(builder);
            var jsRule = jsRuleFinder_1.rule;
            var isTypeScript = String(jsRule.test).indexOf('ts') >= 0;
            jsRule.test = isTypeScript ? /\.tsx?$/ : /\.jsx?$/;
            if (jsRule.use && jsRule.use.loader && jsRule.use.loader.indexOf('babel') >= 0) {
                jsRule.use.options.only = jsRuleFinder_1.extensions.map(function (ext) { return '*.' + ext; });
            }
            builder.config.resolve.extensions =
                ((stack.hasAny('web')
                    || stack.hasAny('server')) ?
                    ['.web.', '.'] : ['.']).map(function (prefix) { return jsRuleFinder_1.extensions.map(function (ext) { return prefix + ext; }); })
                    .reduce(function (acc, val) { return acc.concat(val); });
            if (stack.hasAny('web') && !stack.hasAny('dll')) {
                for (var key in builder.config.entry) {
                    var entry = builder.config.entry[key];
                    for (var idx = 0; idx < entry.length; idx++) {
                        var item = entry[idx];
                        if (item.startsWith('./')
                            && ['.js', '.jsx', '.ts', '.tsx'].indexOf(path.extname(item)) >= 0
                            && item.indexOf('node_modules') < 0) {
                            var jsxItem = './' + path.join(path.dirname(item), path.basename(item, path.extname(item))) + (isTypeScript ? '.tsx' : '.jsx');
                            if (!fs.existsSync(item) && fs.existsSync(jsxItem)) {
                                entry[idx] = jsxItem;
                            }
                        }
                    }
                }
            }
        }
    };
    return ReactPlugin;
}());
exports.default = ReactPlugin;
//# sourceMappingURL=ReactPlugin.js.map