"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var JSRuleFinder = (function () {
    function JSRuleFinder(builder) {
        var jsCandidates = [String(/\.js$/), String(/\.jsx?$/), String(/\.ts$/), String(/\.tsx?$/)];
        for (var _i = 0, _a = builder.config.module.rules; _i < _a.length; _i++) {
            var rule = _a[_i];
            if (jsCandidates.indexOf(String(rule.test)) >= 0) {
                this.rule = rule;
                break;
            }
        }
        if (!this.rule) {
            this.rule = { test: /\.js$/ };
            builder.config.module.rules = builder.config.module.rules.concat(this.rule);
        }
    }
    Object.defineProperty(JSRuleFinder.prototype, "extensions", {
        get: function () {
            var testStr = String(this.rule.test);
            if (testStr.indexOf('jsx') >= 0) {
                return ['jsx', 'js'];
            }
            else if (testStr.indexOf('js') >= 0) {
                return ['js'];
            }
            else if (testStr.indexOf('tsx') >= 0) {
                return ['tsx', 'ts', 'jsx', 'js'];
            }
            else if (testStr.indexOf('ts') >= 0) {
                return ['ts', 'js'];
            }
        },
        enumerable: true,
        configurable: true
    });
    return JSRuleFinder;
}());
exports.default = JSRuleFinder;
//# sourceMappingURL=JSRuleFinder.js.map